/***********
 This module is provided as an example of creating a Node PACKAGE, which could be published to NPM.

 Any modules within subfolders should be made into packages *create a package.json, e.g. by running 'npm init' in the directory).
 Otherwise NPM may clean up subfolders when running npm commands.
 **********/
const omnis_calls = require('omnis_calls');
http = require('http');
https = require('https');
const crypto = require('crypto')
const fs = require('fs');
const os = require('os');
const path = require('path');
var logoMessage = "Failed to download: ";
var logoArray = [];
let autoSendResponse = true;
/**
 * Implement all of your publicly accessible methods in methodMap.
 */
const methodMap = {

    processLogos: function(param, response) {
        autoSendResponse = false;
        //get path
        function getPath(){
            var isWin = process.platform === "win32";
            if(isWin)
                return os.homedir()+"\\Library\\LOCALAPPDATA%\\Suran\\logos\\CDM+\\"
            else
                return os.homedir()+"/Library/Application Support/Suran/logos/CDM+/"
        }

        //download logos
        async function downloadFile(logos, manifestLogos){
            let promises = logos.map((logoID) => {
                return new Promise((resolve, reject) => {
                    let file = fs.createWriteStream(getPath()+"LogoCDM_"+logoID+"_545x204.png");
                    https.get("https://logos.suran.com/cdm/LogoCDM_"+logoID+"_545x204.png", function(resp) {
                        resp.pipe(file);
                        file.on('finish', function() {
                            //if(manifestLogos.filter(item => item.checksum === String(generateChecksum(logoID))).length == 0)
                            logoArray.push(logoID);
                            //omnis_calls.sendResponse({"result": "Failed to download logo"+logoArray}, response);
                            file.close();
                            resolve(logoID);
                        });
                    });
                });
            });
            return Promise.allSettled(promises).then(function(values){
			  	//omnis_calls.sendResponse({"result": "Failed to download logo"}, response);
			  	return logoArray;
			});
        }

        //delete logos
        function deleteFile(logoID){
            var path = getPath()+"LogoCDM_"+logoID+"_545x204.png";
            try {
                fs.unlinkSync(path)
              } catch(err) {
                console.error(err)
              }
        }

        //downloads a new manifest
        async function getManifest(){
            //return new Promise((resolve, reject) => {
                let file2 = fs.createWriteStream(getPath()+"manifest.json");
                request = https.get("https://logos.suran.com/cdm/catalog.json", function(res) {   
                    res.pipe(file2);
                    file2.on('finish', function() {
                        //let logoMessage = logoActions().then(res => {return res});
                        omnis_calls.sendResponse({"result": "Failed to download: "+logoActions().then(res => {return res})}, response); //returns Failed to download [object Promise]
                        /*let logoMessage = logoActions().then(res => {
                            omnis_calls.sendResponse({"result": "Failed to download logo"+res}, response);//crashes
                            return res;
                        });*/
                        //resolve(logoMessage);
                        file2.close();
                    })
                });
            //});
        }
        
        getManifest()
        //omnis_calls.sendResponse({"result": "Failed to download logo"}, response);// returns Failed to download logo

        //get array of currently downloaded logos
        function findFilesInDir(startPath){
            var results = [];
            if (!fs.existsSync(startPath)){
                return;
            }
            var files=fs.readdirSync(startPath);
            for(var i=0;i<files.length;i++){
                if(files[i] != "manifest.json" && files[i] != ".DS_Store"){
                    temp = files[i];
                    temp = temp.split("_");
                    results.push(temp[1]);
                }
            }
            return results;
        } 

        //convert manifest to list
        function convertManifest(){
            var manifestLogoID = new Array;
            manifest = fs.readFileSync(getPath()+'manifest.json');
            manifestList = JSON.parse(manifest);
            return manifestList;
        }

        //compare manifest with downloaded logos
        function getDeleteList(manifestLogos, currentLogos){
            var deleteList = new Array;
            for(var i = 0; i<currentLogos.length; i++){
                if(manifestLogos.filter(item => item.id === parseInt(currentLogos[i])).length == 0){
                    deleteFile(currentLogos[i]);
                }
                else if(manifestLogos.filter(item => item.checksum === String(generateChecksum(currentLogos[i]))).length == 0){
                    deleteList.push(parseInt(currentLogos[i]));
                }
            }
            return deleteList;
        }
        function getDownloadList(manifestLogos, currentLogos){
            var downloadList = new Array;
            for(var i = 0; i<manifestLogos.length; i++){
                if(!(currentLogos.includes((manifestLogos[i].id).toString()))){
                    downloadList.push(manifestLogos[i].id);
                }   
            }
            return downloadList
        }

        function logoActions(){
            var manifestLogos = convertManifest();
            var currentLogos = findFilesInDir(getPath());
            deleteList = getDeleteList(manifestLogos,currentLogos);
            downloadList = getDownloadList(manifestLogos,currentLogos);
            toDownload = deleteList.concat(downloadList);
            return downloadFile(toDownload,manifestLogos).then(response => {
                return response;
            });
        }

        //checksum
        function generateChecksum(logoID){
            files = fs.readFileSync(getPath()+"LogoCDM_"+logoID+"_545x204.png");
            const sha1sum = crypto.createHash('sha256').update(files).digest("hex");
            return sha1sum;
        }
    }
};

module.exports = {
    call: function (method, param, response) { // The only requirement of an Omnis module is that it implement this function.

        autoSendResponse = true;

        if (methodMap[method]) {
            const result = methodMap[method](param, response);
            if (autoSendResponse)
                omnis_calls.sendResponse(result, response);
            return true;
        }
        else {
            throw Error("Method '" + method + "' does not exist");
        }

    }
};